'use strict';

var Cuenta = require('../models/cuenta');
var Mesa = require('../models/mesas');
var {sqldb} = require('../db/sqlconnection');
const cuenta = require('../models/cuenta');
const ThermalPrinter = require("node-thermal-printer").printer;
const Types = require("node-thermal-printer").types;
const kiosco_printing = require('./facturaController')
const util = require('util');

async function crearCuenta(req, res) {
    let params = req.body;
   

    if (params.numeroMesa && params.tipoMesa &&  params.productos && ('subTotal' in params)  &&   ('total' in params)) {
          
            
        let data = {nombreCliente:params.nombreDelCliente,
                    autoPropina:params.propinaAuto,
                    noCuenta:params.cuenta,
                    total: parseFloat(params.total),
                    isactive:true,
                    usuarioAtendio:req.user.user,
                    subTotal :parseFloat(params.subTotal),
                    propina:parseFloat(params.propina),
                    numeroMesa:params.numeroMesa,
                    tipodeMesa:params.tipoMesa,
                    idUsuarioAtendio:req.user.id,
                    idEmpresas: process.env.idEmpresa,
                    numeroComensales:params.numeroComensales
                }
        let  sql = 'INSERT INTO cuentas SET ?'
        const db =sqldb()
         db.query(sql,data,(err,result)=>{
            if(err){
                console.log(err)
                db.end();
                 return res.status(200).send({Error: "db creating cuenta Error"})
            }else{
               // console.log(params)
                const responce = result.insertId
             
                params.productos.map(async (e)=>{
                       // console.log("responce!!!!",responce)
                        data = {idAreaImpresora:e.areaImpresora,
                            codigo:e.codigo,idCuenta:responce,
                             noCuenta:params.cuenta,precio:e.precio,
                             numeroMesa:params.numeroMesa,
                             tipo: e.tipo,
                             nombre:e.platillo,opciones:JSON.stringify(e.opciones),
                             cancelacion:e.cancelacion,
                             cantidad :e.cantidad,
                             impreso:e.impreso,
                             comentario:e.comentario,
                             precioCosto:e.precioCosto,
                             idEmpresas:e.idEmpresas,
                             idProductos:e.idProductos,
                             idTipoProductos :e.idTypeProductos}
                        sql = 'INSERT INTO productosencuenta SET ?'
            
                   await db.query(sql,data,(err,result2)=>{
                        if(err){
                              sql = `DELETE from cuentas WHERE id = ${responce}`;
   
                             db.query(sql,(err,result)=>{
                              if(err){
                                  console.log(err)
                                  db.end();
                                  return res.status(200).send({Error: "db  Error"})
                              }else{
                                db.end();
                                return res.status(200).send({Error: "db inserting producto Error"})
                              }

                            })
                         
                        }else{
                            db.end();
                            return res.status(200).send({responce:responce,_id:result2.insertId})
                        }
                    
                    })
                })
                
            
            }
           
        })
       /* let cuenta = new Cuenta();
        cuenta.usuarioAtendio = params.usuarioAtendio;
        cuenta.numeroMesa = params.numeroMesa;
        cuenta.tipoMesa = params.tipoMesa;
        cuenta.nombreDelCliente = params.nombreDelCliente;
        cuenta.productos = params.productos;
        cuenta.precio = params.precio;
        cuenta.subTotal = params.subTotal;
        cuenta.propina = params.propina;
        cuenta.total = params.total;
        cuenta.cuenta = params.cuenta;
        cuenta.propinaAuto = params.propinaAuto;

        cuenta.save((err, cuentaSave) => {
            if (err) {
                return res.status(500).send({ message: err })
            } else {
                if (!cuentaSave) {
                    return res.status(404).send({ message: 'No se pudo guardar la cuenta' })
                } else {
                    console.log(cuentaSave._id);
                    nuevaMesa(cuentaSave);
                    
                    return res.status(200).send(cuentaSave._id);
                }
            }
        });*/
    }else{
     
        return res.status(200).send({Error: "Error crear cuenta"})
    }
    
}

function nuevaMesa(cuenta){

    Mesa.findOneAndUpdate({
        $and: [
            { numero: cuenta.numeroMesa },
            { tipo: cuenta.tipoMesa }
        ]
    },{
        $push: {
            cuentas: cuenta
        }
    },
        function(err, updated) {
            if (err) return false

            if (!updated) return false

            return true
        }
    );
}


async function  actualizarCuenta(req, res) {
    console.log('funcion: actualizar cuenta');
    let params = req.body;
    let cuentaID = params._id;
   
    
    const db =sqldb()
    const dbQuery = util.promisify(db.query).bind(db);
    let  sql = `SELECT * from cuentas WHERE numeroMesa = '${params.numeroMesa}' AND noCuenta = ${params.cuenta}`;
    const mesa = await dbQuery(sql);
    if(mesa.Error){
        db.end();
        return   res.status(200).send({Error:mesa.Error.toString()})
    }
    
   // console.log(mesa)
    sql = `SELECT * from productosencuenta WHERE numeroMesa = '${params.numeroMesa}' AND noCuenta = ${params.cuenta} `;
    const productoscuenta = await dbQuery(sql);
    if(productoscuenta.Error){
        db.end();
        return   res.status(200).send({Error:productoscuenta.Error.toString()})
    }

   // console.log(productoscuenta)
   if(!(params.changePropina)){
    var precio_producto = parseFloat(params.producto.precio * params.producto.cantidad)
  

    console.log(precio_producto + mesa[0].subTotal,params.subTotal)


    if( precio_producto+ mesa[0].subTotal == params.subTotal ){
        console.log("son iguales")
        sql = `UPDATE cuentas SET autoPropina=${params.propinaAuto}, nombreCliente ='${params.nombreDelCliente}' ,noCuenta = ${params.cuenta},total =  ${parseFloat(params.total)},subTotal = ${parseFloat(params.subTotal)},propina=${parseFloat(params.propina)},numeroMesa=${params.numeroMesa} WHERE id = ${cuentaID}`;
    }else{
        console.log("CORREGIR CUENTA")
        const temp_subtotal = precio_producto + mesa[0].subTotal
        let propina = 0.00
        if(params.propinaAuto && !(params.propina == 0)){
            console.log("autopropina")
            propina = Math.trunc(temp_subtotal * 0.1);
        }else{
          
            propina = mesa[0].propina
        }
        const total = temp_subtotal + propina
        console.log(temp_subtotal,propina,total)
        sql = `UPDATE cuentas SET autoPropina=${params.propinaAuto}, nombreCliente ='${params.nombreDelCliente}' ,noCuenta = ${params.cuenta},total =  ${parseFloat(total)},subTotal = ${parseFloat(temp_subtotal)},propina=${parseFloat(propina)},numeroMesa=${params.numeroMesa} WHERE id = ${cuentaID}`;
    }
   }else{
      sql = `UPDATE cuentas SET autoPropina=${params.propinaAuto}, nombreCliente ='${params.nombreDelCliente}' ,noCuenta = ${params.cuenta},total =  ${parseFloat(params.total)},subTotal = ${parseFloat(params.subTotal)},propina=${parseFloat(params.propina)},numeroMesa=${params.numeroMesa} WHERE id = ${cuentaID}`;
   }
    
        
        await db.query(sql,(err,result)=>{
            if(err){
                console.log(err)
                db.end();
                return res.status(200).send({Error: "db  Error"})
            }
        
        
            if(params.producto){
            console.log("ENTRA")
            var array = []
            array.push(params.producto)
        
            array.map(e=>{ 
                let data = {idAreaImpresora:e.areaImpresora,
                                codigo:e.codigo,
                                idCuenta:cuentaID,
                                noCuenta:params.cuenta,
                                precio:e.precio,
                                numeroMesa:params.numeroMesa,
                                tipo: e.tipo,nombre:e.platillo,
                                opciones:JSON.stringify(e.opciones),
                                cancelacion:e.cancelacion,
                                cantidad :e.cantidad,
                                impreso:e.impreso,
                                comentario:e.comentario,
                                precioCosto:e.precioCosto,
                                idEmpresas:e.idEmpresas,
                                idProductos:e.idProductos,
                                idTipoProductos :e.idTypeProductos}
                    sql = 'INSERT INTO productosencuenta SET ?'
        
                db.query(sql,data,(err,result2)=>{
                    if(err){
                        console.log("ERROR 2:",err)
                        db.end();
                        return res.status(200).send({Error: "db  Error"})
                    } 
            //     console.log("result",result2)
                    console.log("wuue data")  
                    db.end();
                    if( precio_producto+ mesa[0].subTotal == params.subTotal ){
                        return res.status(200).send({id:result2.insertId});
                    }else{
                        return res.status(200).send({id:result2.insertId,getcuenta:true});
                    }
                  
                
                })
            })
            }else{
                console.log("QUISASDFASD")
                return res.status(200).send({id:result});
                
            }
        
        })
    
     
  /*  Cuenta.findByIdAndUpdate(
        cuentaID,
        params,
        (err, cuentaActualizada) => {
            if (err){
                return res.status(500).send({ message: 'Error al actualizar la cuenta' });
            } else{
                if (!cuentaActualizada){
                    return res.status(404).send({ message: 'No se pudo actualizar la cuenta' });
                } else {
                    updateMesa(params);
                    return res.status(200).send(params);;
                }
            }
        }
    );*/
}

function removeItemfromCuenta(req, res) {
    console.log('funcion: remove from cuenta');
    let params = req.body;
    let cuentaID = params._id;
    
 
    let  sql = `UPDATE cuentas SET nombreCliente ='${params.nombreDelCliente}' ,noCuenta = ${params.cuenta},total =  ${parseFloat(params.total)},isactive = ${true},usuarioAtendio = '${req.user.user}',subTotal = ${parseFloat(params.subTotal)},propina=${params.propina},numeroMesa=${params.numeroMesa} WHERE id = ${cuentaID}`;
   
    const db =sqldb()
    let query = db.query(sql,(err,result)=>{
        if(err){
            console.log(err)
            db.end();
            return res.status(200).send({Error: "db Error"})
        }
        
       // console.log(params.productos)
       const id = params.productos[0]._id
   
           // let  sql = `UPDATE productosencuenta SET cancelacion =${true}  WHERE id = ${id}`;
           if(params.productos[0].impreso){
            db.end();
            return res.status(200).send({Error:"Producto ya fue impreso"})
           }
           let  sql = `DELETE from productosencuenta WHERE id = ${id}`;
   
            db.query(sql,(err,result2)=>{
                if(err){
                    console.log("ERROR 2:",err)
                    db.end();
                    return res.status(200).send({Error:"db Error"})
                }
                db.end();
                return res.status(200).send({result2});
            
            })
      
    })
}

function printItem(req, res) {
    let params = req.body;
    let  sql = `UPDATE productosencuenta SET impreso = ${true} WHERE id = ${params.product._id}`;
    //db.query(sql);
    const db =sqldb()
          
     db.query(sql,async(err,result2) => {
        if(err){
            console.log(err)
            db.end();
            return res.status(200).send({Error:"db Error"})
        }
        db.end();
        return res.status(200).send(result2)
    })
    
}


function anularItemfromCuenta(req, res) {
    console.log('funcion: remove from cuenta');
    let params = req.body;
    let cuentaID = params._id;
 
    let  sql = `UPDATE cuentas SET nombreCliente ='${params.nombreDelCliente}' ,noCuenta = ${params.cuenta},total =  ${parseFloat(params.total)},isactive = ${true},usuarioAtendio = '${req.user.user}',subTotal = ${parseFloat(params.subTotal)},propina=${params.propina},numeroMesa=${params.numeroMesa} WHERE id = ${cuentaID}`;
   
    const db =sqldb()
    let query = db.query(sql,(err,result)=>{
        if(err){
            console.log(err)
            db.end();
            return res.status(200).send({Error: "db Error"})
        }
        
       // console.log(params.productos)
       const id = params.productos[0]._id
           

        
        
         /*
           if(params.productos[0].impreso){
               console.log("ya fue impreso")
            return res.status(200).send({Error:"Producto ya fue impreso"})
           }*/
           let  sql = `UPDATE productosencuenta SET cancelacion = ${params.productos[0].cancelacion}  WHERE id = ${id}`;
   
            db.query(sql,(err,result2)=>{
                if(err){
                    console.log("ERROR 2:",err)
                    db.end();
                    return res.status(200).send({Error:"db Error"})
                }
               // console.log("result",result2)
                db.end();
                return res.status(200).send({result2});
            
            })
      
    })
}

function updateMesa(cuenta){
    Mesa.update({
        'cuentas._id': cuenta._id
    },{
        $set:{
            'cuentas.$.productos': cuenta.productos,
            'cuentas.$.nombreDelCliente': cuenta.nombreDelCliente,
            'cuentas.$.subTotal': cuenta.subTotal,
            'cuentas.$.propina': cuenta.propina,
            'cuentas.$.total': cuenta.total,
            'cuentas.$.propinaAuto': cuenta.propinaAuto                   
        }
    },
    (err, updated) => {
        if (err) return status(500).send({ message: 'Error al actualizar la mesa' });

        if (!updated) return status(404).send({ message: 'No se pudo actualizar la mesa' });
        
      //  console.log(updated);
        
        return true;
    });
}

async function printComanda(req, res) {
  
    var params = req.body;
    let ErrorArray = []
    let kiosco_products = []
    let data_base = JSON.parse(JSON.stringify(req.body));
    var productos_temp = []

    const db =sqldb()
    const dbQuery = util.promisify(db.query).bind(db);
   
    
      
    var i = 0
    while(i < params.cuentas.length){
        const result3 = params.cuentas[i].productos.filter(e => {
          
            return e.impreso == false && !(e.producto.idTipoProductos === parseInt( process.env.idproductosKioscoImpresion))
        });
        var productType2 = params.cuentas[i].productos.filter(e =>{
           // console.log(e.producto.idTipoProductos)
            return e.producto.idTipoProductos === parseInt( process.env.idproductosKioscoImpresion) && e.impreso == false 
        });
       
       
        if(productType2 && productType2.length>0){
            kiosco_products.push({prod:productType2,
            idCuenta:params.cuentas[i]._id,
            noCuenta:params.cuentas[i].cuenta})
        }
      
        params.cuentas[i].productos =  result3
    
        i = i +1
    }

    
    
   
    let  sql = `SELECT * from area_Impresoras WHERE  idEmpresas = '${process.env.idEmpresa}' ORDER BY  idareaImpresora ASC`;
    const result2 = await dbQuery(sql);

    if(result2.Error){
        db.end();
        return res.status(200).send({Error:[{Error:"error buscando impresoras"}]} )
    }
    
      
         
         // const printing_response = await testConnection(params.cuentas,result2)
       
        var printing_response2 = []
        var printing_response_resumenCuenta = []
        var printing_response = await printingData(params.cuentas,result2)
        var respPrinter;

        
        if(parseInt(process.env.COMANDA_CENTRAL)){

            let printers_resumen_central = result2.filter(e => {
                return e.id == process.env.COMANDA_CENTRAL
            });

            printing_response_resumenCuenta = await printingResumenCuenta(params.cuentas,printers_resumen_central)

            let printers_resumen_caja = result2.filter(e => {
                return e.idUsuario == req.user.id
            });

            printing_response_resumenCuenta = await printingResumenCuenta(params.cuentas,printers_resumen_caja)
            
        }
        
       
        const printerCaja = result2.filter(e => {
            
            return e.name.toLowerCase() == 'caja' 
        });
        console.log("id de usuario", req.user.id)
        sql = `SELECT * from documentosCorrelativos where idUsuarios= '${req.user.id}' AND idDocumentos='${process.env.idDocumentos}' AND idEmpresas = '${process.env.idEmpresa}'`
        const result9 = await dbQuery(sql);

        if(result9.Error){
            db.end();
            return  res.status(200).send( {Error:[{Error:"db Error kiosco correlativo get"}]} )
        }

           
           
            if(result9.length == 0){
              
                res.status(200).send({Error:[{Error:"No se Encontro ningun correlativo para este usuario o empresa"}]} )
                db.end()
                return  
            }
            var cor_temp = result9[0].correlativo
            var index_temp = 0

          
            while(index_temp < kiosco_products.length){
            if(kiosco_products.length>0 && printerCaja.length>0){
                
                  
                    var index = 0
                    var sumofProducts = 0
                    while (index< productType2.length) {
                        sumofProducts = parseInt(sumofProducts +  parseInt(productType2[index].cantidad))
                        index = index + 1
                    }
                    var correlativo = parseInt(cor_temp) + sumofProducts
                    var correlativo_string = ( parseInt(cor_temp)+1).toString() + " - " + correlativo.toString()
                    if((parseInt(cor_temp)+1) == correlativo){
                            correlativo_string =  correlativo.toString()
                    }
                    respPrinter =  await kiosco_printing.printTickets(kiosco_products[index_temp].prod,params.cuentas[0],printerCaja[0].ipAddress,correlativo_string)

                    let  sql2 = `UPDATE documentosCorrelativos SET correlativo = ${correlativo.toString()} WHERE idUsuarios = ${req.user.id} AND  idDocumentos='${process.env.idDocumentos}' AND idEmpresas = '${process.env.idEmpresa}'`;
                    const result8 = await dbQuery(sql2);

                    if(result8.Error){
                        db.end();
                        return    res.status(200).send({Error:[{Error:"db Error kiosco correlativo set"}]})
                    }
                    
            }
          
            if(respPrinter == false){
                ErrorArray.push({Error:"Error de Conexion en Impresora " + printerCaja[0].name + " "+ " ticket",
                    idCuenta:kiosco_products[index_temp].idCuenta,
                    NoCuenta:kiosco_products[index_temp].noCuenta}) 
            }else{
                const Message = "Imprecion Exitosa en  " + printerCaja[0].name
                printing_response2.push({success:Message,
                                    idCuenta:kiosco_products[index_temp].idCuenta,
                                    NoCuenta:kiosco_products[index_temp].noCuenta})
            }
            cor_temp = correlativo
            index_temp = index_temp + 1
        }
            
 
    //console.log(printing_response)
    if(printing_response2 && printing_response2.length>0){
        

        printing_response2.sort(function(a, b) {
            if(a.idCuenta && b.idCuenta){
               return a.idCuenta - b.idCuenta;
            }
          
       });
       //console.log(printing_response)
   
    //   console.log("ENTRA ACTUALIZAR")
           let cuentas = params.cuentas;
           var m, n;
           m = 0;
        
           while(m < printing_response2.length) {
              
           
               if((printing_response2[m].success)){
                   var result5 = data_base.cuentas.filter(e => {
                        
                       return e._id == printing_response2[m].idCuenta 
                   });

                  var data_temp2 =  result5[0].productos.filter(e => {
                        
                    return e.impreso == false && e.producto.idTipoProductos === parseInt( process.env.idproductosKioscoImpresion)
                });

              
                
                  
                  
                   if(printing_response2[m].idCuenta == result5[0]._id){
                        n = 0;
                       
                       while(n < data_temp2.length) {
                               
                                        let  sql = `UPDATE productosencuenta SET impreso = ${true} WHERE id = ${data_temp2[n]._id}`;
                                        //db.query(sql);
                                        const result2 = await dbQuery(sql);

                                        if(result2.Error){
                                         //   db.end();
                                            console.log(result2.Error)
                                          //  return    res.status(200).send({Error:[{Error:"db Error "}]})
                                        }
                                       
                                           
                                           
                                            result5[0].productos[n].impreso = true
                                            productos_temp.push(data_temp2[n])
                       
                                            n++;
                       }
                   }
               }else{
               // console.log("ENTRA")
                   ErrorArray.push(printing_response2[m])
               }
           
               m++;
           }
           
       
       }
      
    if(printing_response_resumenCuenta.Done && printing_response_resumenCuenta.Done.length>0){
        printing_response_resumenCuenta.Done.sort(function(a, b) {
            if(a.idCuenta && b.idCuenta){
            return a.idCuenta - b.idCuenta;
            }
        
        });

        var m, n;
        m = 0;
        while(m < printing_response_resumenCuenta.Done.length) {
           
            
            if(!(printing_response_resumenCuenta.Done[m].success)){
                ErrorArray.push(printing_response_resumenCuenta.Done[m])
            }
            m++
        }
    }
   
  
    //console.log(printing_response)
    if(printing_response.Done && printing_response.Done.length>0){

       
        

         printing_response.Done.sort(function(a, b) {
             if(a.idCuenta && b.idCuenta){
                return a.idCuenta - b.idCuenta;
             }
           
        });
        //console.log(printing_response)
    
     //   console.log("ENTRA ACTUALIZAR")
           
            var m, n;
            m = 0;
            var result6;
            while(m < printing_response.Done.length) {
            
                
                if((printing_response.Done[m].success)){
                     result6 = params.cuentas.filter(e => {
            
                        return e._id == printing_response.Done[m].idCuenta 
                    });
                  
                  
                    
                    if(printing_response.Done[m].idCuenta == result6[0]._id){
                        n = 0;
                        while(n < result6[0].productos.length) {
                                
                                   if( result6[0].productos[n].impreso == false){
                                        let  sql = `UPDATE productosencuenta SET impreso = ${true} WHERE id = ${result6[0].productos[n]._id}`;
                                        //db.query(sql);
                                        const result2 = await dbQuery(sql);

                                        if(result2.Error){
                                        //   db.end();
                                            console.log(result2.Error)
                                        //  return    res.status(200).send({Error:[{Error:"db Error "}]})
                                        }
                                        
                                        result6[0].productos[n].impreso = true
                                        productos_temp.push(result6[0].productos[n])
                                   }
                        
                            n++;
                        }
                    }
                }else{
                // console.log("ENTRA")
                    ErrorArray.push(printing_response.Done[m])
                }
            
                m++;
            }
           // console.log(ErrorArray)
         
            
            if(ErrorArray.length> 0){
               
                db.end();
                return res.status(200).send({Error:ErrorArray});
            }
            db.end();
            return res.status(200).send(params.cuentas);
        
        }else{
        
            if(ErrorArray.length> 0){
                console.log(ErrorArray)
                db.end();
                return res.status(200).send({Error:ErrorArray});
            }
            db.end();
            return res.status(200).send(params.cuentas);
        }
    
    
}

async function printingResumenCuenta (items,printerts) {
   
    var cont = 0
    let ts = Date.now();
    let date_ob = new Date(ts);
    var StatusMessage = []
    let result3 = []
 
    while(cont < printerts.length){
            for(let a = 0; items.length > a; a++ ){
           // console.log("CUENTAAA", items[a].cuenta)
            var printerProducts = items[a].productos
 
            
           
            if(printerProducts.length > 0 ){
                    let printer =  new ThermalPrinter({type: Types.EPSON, interface: printerts[cont].ipAddress.toString()});
                    let printerConection =  await printer.isPrinterConnected();
                    console.log("Printer  connected:", printerConection + printerts[cont].ipAddress.toString());
               
                    console.log("Printer NAME",printerts[cont].name)
                    printer.newLine();    
                    printer.newLine();    
                    printer.newLine();    
                    printer.newLine();    
                    printer.newLine();    
                    printer.newLine();

                    //Ubicación de la comanda
                    printer.setTextSize(1,0);
                    printer.println('#' + items[a]._id);
                    printer.bold(true);
                    printer.println(printerts[cont].name);
                    printer.bold(false);

                    //Detalle de la mesa
                    printer.setTextNormal(); 
                    printer.println(items[0].tipoMesa + ": MESA " + items[0].numeroMesa);
                    printer.println(date_ob);
                    printer.println(items[0].usuarioAtendio);
                    printer.println("A*");
                


                    printer.setTextSize(1,0);
                    printer.bold(true);
                    printer.println("LOCAL");
                    printer.bold(false);
                    printer.setTextNormal();
                    

                    printer.drawLine();

            
                
                    
                    //if(barProducts.length == 0){
                        if(items[a].nombreDelCliente == "undefined" || items[a].nombreDelCliente == null || items[a].nombreDelCliente == '' ){
                            printer.println('Cuenta No.' + (items[a].cuenta));
                        }else{
                            printer.println("Cliente: " + items[a].nombreDelCliente);
                        }
                        
                        if(items[a].numeroComensales){
                            printer.println('Comensales: ' + (items[a].numeroComensales));
                        }
                        printer.drawLine();
                    //}

                        
                      
                      //  barProducts = []
                    
                        
                 
                for(let b = 0; printerProducts.length > b; b++ ){
                
                    
                            if(!printerProducts[b].impreso && !printerProducts[b].cancelacion){
                               
                                
                                printer.bold(true);
                                printer.println(printerProducts[b].cantidad + "  " + printerProducts[b].platillo);
                                //console.log(printerProducts[b].cantidad + "  " + printerProducts[b].platillo)
                                printer.bold(false);
                                
                
                                for (let j = 0; printerProducts[b].opciones.length > j; j++) {
                                    let selection = printerProducts[b].opciones[j].opcionSeleccionada;
                                    let tittleopcion = printerProducts[b].opciones[j].nombreopcion;
                                    printer.println("   + " + selection);
                                   
                               
                                }
                
                                if(printerProducts[b].comentario != ""){
                                    printer.println("   > " + printerProducts[b].comentario);
                                    
                                }   
                            }
                        
                    }
                
             
                printer.drawLine();
                printer.newLine();  
                printer.cut();
              //  console.log(printer.getText()); 

  
                if(printerConection){
                    try {
                       // console.log("EXECUTE!")
                        let execute = printer.execute()
                        const Message = "Imprecion Exitosa en  " + printerts[cont].name
                        StatusMessage.push({success:Message,
                                            idCuenta:items[a]._id,
                                            NoCuenta:items[a].cuenta})
                      } catch (error) {
                        console.log(error)
                        const errorMessage = "Error: Impresion Resumen de Cuenta,Conexion en Impresora " + printerts[cont].name
                        StatusMessage.push({Error:errorMessage,
                                            idCuenta:items[a]._id,
                                            NoCuenta:items[a].cuenta})
                      }
                }else{
                   
                    const errorMessage = "Error: Impresion Resumen de Cuenta,Conexion en Impresora " + printerts[cont].name
                 
                    StatusMessage.push({Error:errorMessage,
                                        idCuenta:items[a]._id,
                                        NoCuenta:items[a].cuenta})
                }
            }
        }       
        cont = cont + 1;
    }
    
    return {Done: StatusMessage}; 
    
}

async function printingData (items,printerts) {
    let ts = Date.now();
    let date_ob = new Date(ts);

    // current date
    // adjust 0 before single digit date
    let date = ("0" + date_ob.getDate()).slice(-2);

    // current month
    let month = ("0" + (date_ob.getMonth() + 1)).slice(-2);

    // current year
    let year = date_ob.getFullYear();

    // current hours
    let hours = date_ob.getHours();

    // current minutes
    let minutes = date_ob.getMinutes();

    // current seconds
    let seconds = date_ob.getSeconds();

    let fecha = date + "-" + month + "-" + year;

    let tiempo = hours + ':' + minutes;
    
    var cont = 0;

    var barProducts = []
    var StatusMessage = []
    let result3 = []
    var num_cuenta = 0;
    var printBAR = 0;
 
    while(cont < printerts.length){
            for(let a = 0; items.length > a; a++ ){
           // console.log("CUENTAAA", items[a].cuenta)
            var printerProducts = items[a].productos.filter(e =>{
               
                return e.idAreaImpresora == printerts[cont].idareaImpresora
            });


           
           
            if(printerts[cont].name.toLowerCase() === process.env.barName && barProducts.length >0){

                 result3 = barProducts.filter(e => {
  
                    return e.cuenta ==  items[a].cuenta
                });
                //console.log(result3)
            } 
            
           
            if(printerProducts.length > 0 || (result3.length>0 && printerts[cont].name.toLowerCase() === process.env.barName)){
                let printer =  new ThermalPrinter({type: Types.EPSON, interface: printerts[cont].ipAddress.toString()});
                let printerConection =  await printer.isPrinterConnected();
                console.log("Printer  connected 100:", printerConection + printerts[cont].ipAddress.toString());
               
            console.log("Printer NAME",printerts[cont].name)
            // printer.newLine();    
            // printer.newLine();    
            // printer.newLine();    
            // printer.newLine();    
            printer.newLine();    
            printer.newLine();

            //Ubicación de la comanda
            printer.setTextSize(1,0);
            printer.println('#' + items[a]._id);
            printer.bold(true);
            printer.println(printerts[cont].name);
            printer.println(items[0].tipoMesa + " : " + items[0].numeroMesa);
            printer.println(tiempo);
            printer.bold(false);

            printer.setTextNormal(); 
            printer.println(fecha);
            printer.println(items[0].usuarioAtendio);

            printer.drawLine();
            printer.setTextSize(1,0);
            printer.bold(true);
                    //if(barProducts.length == 0){
                if(items[a].nombreDelCliente == "undefined" || items[a].nombreDelCliente == null || items[a].nombreDelCliente == '' ){
                    printer.println('Cuenta No.' + (items[a].cuenta));
                }else{
                    printer.println("Cliente: " + items[a].nombreDelCliente);
                }
                if(items[a].numeroComensales){
                    printer.println('Comensales: ' + (items[a].numeroComensales));
                }

            printer.bold(false);
            printer.setTextSize(0,0);
            printer.drawLine();
                    //}

                        
                      
                       // console.log(barProducts)
            for(let aux = 0; result3.length > aux; aux++ ){
                //console.log("PROD",barProducts[aux])
                printer.bold(true);
                printer.println(result3[aux].cantidad + "  " + result3[aux].platillo);
                
                printer.bold(false);
            }
                      //  barProducts = []
                    
                        
                 
                for(let b = 0; printerProducts.length > b; b++ ){
                
                    
                            if(!printerProducts[b].impreso && !printerProducts[b].cancelacion){
                               
                                
                                printer.bold(true);
                                printer.println(printerProducts[b].cantidad + "  " + printerProducts[b].platillo);
                                //console.log(printerProducts[b].cantidad + "  " + printerProducts[b].platillo)
                                printer.bold(false);
                                
                
                                for (let j = 0; printerProducts[b].opciones.length > j; j++) {
                                    let selection = printerProducts[b].opciones[j].opcionSeleccionada;
                                    let tittleopcion = printerProducts[b].opciones[j].nombreopcion;
                                    if(!(process.env.ARRAY_BEBIDA_TYPE.includes(tittleopcion.toString().toLowerCase())) 
                                    || printerts[cont].name.toLowerCase() === process.env.barName){
                                        console.log("NO INBLYUSE")
                                      
                                    //if(!(tittleopcion.toLowerCase() === "bebida" )){
                                        printer.println("   + " + selection);
                                      //  console.log("   + " + selection)
                                    }else  if(process.env.ARRAY_BEBIDA_TYPE.includes(tittleopcion.toString().toLowerCase())){
                                    //if(tittleopcion.toLowerCase() === "bebida" ){
                                        console.log(" INBLYUSE")
                                        barProducts.push({
                                            cantidad:printerProducts[b].cantidad,
                                            platillo:selection,
                                            nombreDelCliente:items[a].nombreDelCliente,
                                            cuenta:items[a].cuenta
                                        })
                                        
                                    }
                               
                                }
                
                                if(printerProducts[b].comentario != ""){
                                    printer.println("   > " + printerProducts[b].comentario);
                                    
                                }   
                            }
                        
                    }
                
             
                printer.drawLine();
                printer.cut();
              //  console.log(printer.getText()); 

  
                if(printerConection){
                    try {
                        let execute = printer.execute()
                        
                        const Message = "Imprecion Exitosa en  " + printerts[cont].name
                        StatusMessage.push({success:Message,
                                            idCuenta:items[a]._id,
                                            NoCuenta:items[a].cuenta})
                      } catch (error) {
                         console.log()
                          console.log(error)
                        const errorMessage = "Error de Conexion en Impresora " + printerts[cont].name
                 
                        StatusMessage.push({Error:errorMessage,
                                            idCuenta:items[a]._id,
                                            NoCuenta:items[a].cuenta})
                      }
                }else{
                   
                    const errorMessage = "Error de Conexion en Impresora " + printerts[cont].name
                 
                    StatusMessage.push({Error:errorMessage,
                                        idCuenta:items[a]._id,
                                        NoCuenta:items[a].cuenta})
                }
            }
        }       
        cont = cont + 1;
    }
    
    return {Done: StatusMessage}; 
    
}

function actualizarImpresado(cuentas) {
  for(let b = 0; cuentas.length > b; b++){
    let cuentaID = cuentas[b]._id;
    
    for (const producto of cuentas[b].productos) {
      producto.impreso = true;
    }

    Cuenta.findByIdAndUpdate(
        cuentaID,
        cuentas[b],
        (err, cuentaActualizada) => {
            if (err){
                return false;
            } else{
                if (!cuentaActualizada){
                    return false;
                } else {
                    if (updateMesa(cuentas[b]));
                        return cuentas[b];
                }
            }
        }
    );

    
  }
}

async function eliminarCuenta(req, res) {
    let cuentaID = req.params.id;
    console.log(cuentaID)
   // console.log(req.user)
    const db =sqldb()
    const dbQuery = util.promisify(db.query).bind(db);
    let  sql =  `DELETE FROM cuentas WHERE id  IN (${cuentaID})`;
    const datacuenta = await dbQuery(sql);
    if(datacuenta.Error){
        db.end();
        return   res.status(200).send({Error:datacuenta.Error.toString()})
    }
    let  sql2 =  `DELETE FROM productosencuenta WHERE idCuenta  IN (${cuentaID})`;
    const productoCuenta = await dbQuery( sql2 );
    if(productoCuenta.Error){
        db.end();
        return   res.status(200).send({Error:productoCuenta.Error.toString()})
    }
    db.end()
    return  res.status(200).send({ message: 'La cuenta ha sido eliminada' })
    
}

async function clearCuenta(req, res) {
    console.log("clearCuenta")
    let cuentaID = req.params.id;
    console.log(cuentaID)
   // console.log(req.user)
    const db =sqldb()
    const dbQuery = util.promisify(db.query).bind(db);
    let  sql = `UPDATE cuentas SET total=0, subTotal =0 ,propina =0 WHERE id = ${cuentaID}`;
    const datacuenta = await dbQuery(sql);
    if(datacuenta.Error){
        db.end();
        return   res.status(200).send({Error:datacuenta.Error.toString()})
    }
   
    let  sql2 =  `DELETE FROM productosencuenta WHERE idCuenta  IN (${cuentaID})`;
    const productoCuenta = await dbQuery( sql2 );
    if(productoCuenta.Error){
        db.end();
        return   res.status(200).send({Error:productoCuenta.Error.toString()})
    }
    db.end()
    return res.status(200).send({ message: 'La cuenta ha sido Reestablecida' })
    
}
function listarCuentas(req, res) {

    Cuenta.find((err, encontrado) => {
        if (err) {
            res.status(500).send({ message: 'Error al listar las cuentas' });
        } else {
            if (!encontrado) {
                res.status(404).send({ message: 'No se pudo listar las cuentas' })
            } else {
                res.status(200).send(encontrado)
            }
        }
    })
}

function listarCuentasActivas(req, res) {
    Cuenta.find({ active: true }, (err, encontrado) => {
        if (err) {
            res.status(500).send({ message: 'Error al listar las cuentas' });
        } else {
            if (!encontrado) {
                res.status(404).send({ message: 'No se pudo listar las cuentas activas' })
            } else {
                res.status(200).send(encontrado)
            }
        }
    })
}

function buscarCuenta(req, res) {
  
    let cuentaID = req.params.id;
  
    Cuenta.findById(cuentaID, (err, cuentaEncontrada) => {
        if (err) res.status(500).send({ message: 'Error al listar la cuenta' });

        if (!cuentaEncontrada) res.status(404).send({ message: 'No se encontro la cuenta' });

        res.status(200).send({ cuentaEncontrada })
    })
}

module.exports = {
    anularItemfromCuenta,
    removeItemfromCuenta,
    crearCuenta,
    actualizarCuenta,
    eliminarCuenta,
    clearCuenta,
    listarCuentas,
    listarCuentasActivas,
    buscarCuenta,
    actualizarImpresado,
    printComanda,
    printItem
}