'use strict';

const Platillo = require('../models/menu');
var {sqldb} = require('../db/sqlconnection')
function crearPlato(req, res) {
    let params = req.body;
    let plato = new Platillo();

    if (params.tipo && params.codigo && params.nombre && params.precio) {
        plato.tipo = params.tipo;
        plato.codigo = params.codigo;
        plato.nombre = params.nombre;
        plato.precio = params.precio;
        plato.opciones = [];

        plato.save((err, platoSave) => {
            if (err) {
                res.status(500).send({ message: 'Erro al guardar Platillo' });
            } else {
                if (!platoSave) {
                    res.status(404).send({ message: 'No se pudo guardar Platillo' });
                } else {
                    res.status(200).send({ plato: platoSave });
                }
            }
        })
    } else {
        res.status(200).send({ message: 'Ingrese los datos requeridos' });
    }
}

function actualizarPlatillo(req, res) {
    let params = req.body;
    let platoID = req.params.id;

    Platillo.findByIdAndUpdate(platoID, params, { new: true }, (err, platoActualizado) => {
        if (err) {
            res.status(500).send({ message: 'Error al actualizar Platillo' });
        } else {
            if (!platoActualizado) {
                res.status(404).send({ message: 'No se pudo actualizar Platillo' });
            } else {
                res.status(200).send({ platoActualizado });
            }
        }
    });
}

function eliminarPlatillo(req, res) {
    let platoID = req.params.id;

    Platillo.findByIdAndDelete(platoID, (err, platoEliminado) => {
        if (err) {
            res.status(500).send({ message: 'Error al eliminar Platillo' });
        } else {
            if (!platoEliminado) {
                res.status(404).send({ message: 'Error al eliminar Platillo' });
            } else {
                res.status(200).send({ message: 'El platillo ha sido eliminado' });
            }
        } 
    });
}

function listarPlatillos(req, res) {

    Platillo.find((err, encontrado) => {
        if (err) {
            res.status(500).send({ message: 'Error al listar Platillos' })
        } else {
            if (!encontrado) {
                res.status(404).send({ message: 'No hay Platillos' })
            } else {
                res.status(200).send(encontrado)
            }
        }
    })
}

function listarMenuPlatillos(req, res) {
    console.log('SEARCHING MENU')
    var num = req.params.num;
    var tipo = req.params.tipo;

   // console.log(num)
    const type = "Menu"
    let  sql = `SELECT idfamiliaNivel1 from mesas WHERE numero = '${num}' AND idEmpresas = '${process.env.idEmpresa}'`;
    const db =sqldb()
     db.query(sql,(err,result)=>{
     
        if (err) {
            db.end();
               return  res.status(200).send({ Error: 'Al busca el Menu' })
        }

        if(!result || result.length == 0){
            db.end();
            return  res.status(200).send({ Error: 'Al busca el Menu' })
        }
        const responce = result[0]
                if (result.length == 0) {
                    db.end();
                    return  res.status(200).send({ Error: 'No se pudo encontrar el Menu' })
                } else {
                   if(responce.idfamiliaNivel1){
                    let  sql1 = `SELECT * from familiaNivel2 WHERE idFamiliaNivel1 = '${ responce.idfamiliaNivel1}' AND idEmpresas = '${process.env.idEmpresa}' ORDER BY ordenMenu ASC`;
   
                    db.query(sql1,(err,result2)=>{
                        if (err) {
                            db.end();
                            return  res.status(200).send({ Error: 'Al buscar opciones del Menu' })
                         } else {
                            db.end();
                            return res.status(200).send(result2)
                         }
                    })
                   }else{
                    db.end();
                    return  res.status(200).send({ Error: 'No id' })
                   }
                }
            

            
        


     })

      
  
    /*Platillo.find((err, encontrado) => {
        if (err) {
            res.status(500).send({ message: 'Error al listar Platillos' })
        } else {
            if (!encontrado) {
                res.status(404).send({ message: 'No hay Platillos' })
            } else {
                res.status(200).send(encontrado)
            }
        }
    })*/
}

function buscarPlatillo(req, res) {
  
    var platoID = req.params.id;

    Platillo.findById(platoID, (err, encontrado) => {
        if (err) {
            res.status(500).send({ message: 'Error al buscar' });
        } else {
            if (!encontrado) {
                res.status(404).send({ message: 'Error al buscar platillo' })
            } else {
                res.status(200).send(encontrado)
            }
        }
    })
}

function buscarPorTipo(req, res) {
   console.log("buscarPorTipo")
    let idnivel1 = req.params.idnivel1;
    let idnivel2 = req.params.idnivel2;
  //  console.log(idnivel1,idnivel2)
    let  sql = `SELECT * from productos WHERE idFamiliaNivel1 = '${idnivel1}' AND idFamiliaNivel2 = '${idnivel2}' AND idEmpresas = '${process.env.idEmpresa}' ORDER BY ordenMenu ASC`;
    const db =sqldb()
     db.query(sql,(err,result)=>{
      
        if (err) {
           
            db.end();
            res.status(200).send({ message: 'Error al buscar el tipo de mesa' })
        } else {
            
            if (result.length == 0) {
                db.end();
                res.status(200).send({ message: 'No se pudo buscar el tipo de mesa' })
            } else {
                db.end();
                res.status(200).send(result)
            }
        }

    })
    /*
    Platillo.find({ tipo: type }, (err, encontrado) => {
        if (err) {
            res.status(200).send({ message: 'Error al buscar el tipo de mesa' })
        } else {
            if (!encontrado) {
                res.status(200).send({ message: 'No se pudo buscar el tipo de mesa' })
            } else {
                res.status(200).send(encontrado)
            }
        }
    })*/
}

module.exports = {
    crearPlato,
    actualizarPlatillo,
    eliminarPlatillo,
    listarPlatillos,
    buscarPlatillo,
    buscarPorTipo,
    listarMenuPlatillos
}