'use strict';

var Mesa = require('../models/mesas');
const ThermalPrinter = require("node-thermal-printer").printer;
const Types = require("node-thermal-printer").types;
var {sqldb} = require('../db/sqlconnection')

//-------------------------------------guardar mesa------------------------------//

function guardarMesa(req, res) {
    var params = req.body;
    var mesa = new Mesa();

    if (params.numero && params.tipo) {
        mesa.numero = params.numero;
        mesa.tipo = params.tipo;

        mesa.save((err, mesaSave) => {
            if (err) {
                res.status(500).send({ message: 'Error al guardar.' });
            }
            else {
                if (!mesaSave) {
                    res.status(404).send({ message: 'No se pudo guardar.' });
                }
                else {
                    res.status(200).send({ mesas: mesaSave });
                }
            }
        });
    }
    else {
        res.status(200).send({ message: 'Ingrese los datos requeridos' });
    }
}


//---------------------------------actualizar mesa :*------------------------------//

function actualizarMesa(req, res) {
    var params = req.body;
    var mesaID = req.params.id;
   // console.log('actualizar Mesa:' + mesaID);
    // console.log(params.mesaActualizada.cuentas);
    Mesa.findByIdAndUpdate(mesaID, params, { new: true }, (err, mesaActualizada) => {
        if (err) {
            return res.status(500).send({ message: 'Error al actualizar la factura' })
        } else {
            if (!mesaActualizada) {
                return res.status(404).send({ message: 'No se pudo actualizar la factura' })
            } else {
                
                // console.log(mesaID);
                // actualizarCuentaMesa(mesaID);
                res.status(200).send({ message: 'La cuenta ha sido actualizada' })
            }
        }
    });   
}

function agregarCuenta(req, res){
  //  console.log(req)

    var cuenta = req.body;
    var mesaID = req.params.id;

    Mesa.findOneAndUpdate({
        _id: mesaID
    },{
        $push: {
            cuentas: cuenta
        }
    },{
        safe: true, upsert: true
    },
        function(err, updated) {
            if (err) return res.status(500).send({ message: 'Error al actualizar mesa' });

            if (!updated) return res.status(404).send({ message: 'No se pudo actualizar la mesa' });
            
            return res.status(200).send(cuenta);
        }
    );
}

//-------------------------------------borrar mesa :*------------------------------//

function eliminarMesa(req, res) {
    var mesaID = req.params.id

    Mesa.findByIdAndDelete(mesaID, (err, mesaEliminada) => {
        if (err) {
            res.status(500).send({ message: 'Error al eliminar' })
        } else {
            if (!mesaEliminada) {
                res.status(404).send({ message: 'Error al eliminar la mesa' })
            } else {
                res.status(200).send({ message: 'La mesa ha sido eliminada bb' })
            }
        }
    })
}

//------------------------------------listar mesa :*-----------------------------------//

function listarMesa(req, res) {

    Mesa.find((err, encontrado) => {
        if (err) {
            res.status(500).send({ message: 'Error al listar las mesas' })
        } else {
            if (!encontrado) {
                res.status(404).send({ message: 'No se pudo listar las mesas' })
            } else {
                res.status(200).send(encontrado)
            }
        }
    })
}


function buscarMesa(req, res) {
    var numeroMEsa = req.params.id;
    //console.log("buscar mesa!!!!!!!!!!")
  
    
    let  sql = `SELECT * from cuentas WHERE numeroMesa = '${numeroMEsa}'`;
    const db =sqldb()
    db.query (sql,(err,result)=>{
       
        if(err){
            console.log(err)
            db.end();
            return res.status(200).send({Error:"db Error"})
        }
        
     //  return res.status(200).send(result3)
     sql = `SELECT * from productosencuenta WHERE numeroMesa = '${numeroMEsa}' `;
     //  const result3 = result2.filter(e => result[cont].numero == e.numeroMesa);
      db.query (sql,(err,result2)=>{
          if(err){
              console.log(err)
              db.end();
              return res.status(200).send({Error:"db Error"})
          }

        
          var cont = 0
          var array = []
          
         
          
          while(cont<result.length){
              const result3 = result2.filter(e => result[cont].noCuenta == e.noCuenta);
          
              var cuenta = {
                _id:result[cont].id,
                numeroMesa:  result[cont].numeroMesa,
                tipoMesa: '',
                nombreDelCliente: (result[cont].nombreCliente ? (result[cont].nombreCliente): ''),
                productos: [],
                subTotal: result[cont].subTotal,
                propina: result[cont].propina,
                total: result[cont].total,
                cuenta: result[cont].noCuenta,
                propinaAuto: result[cont].autoPropina,
                tipoMesa:result[cont].tipodeMesa,
                usuarioAtendio:result[cont].usuarioAtendio,
                numeroComensales:result[cont].numeroComensales
               
              }

              var con2 = 0
              while(con2 < result3.length){
             
                cuenta.productos.push({
                    _id:result3[con2].id,
                    tipo: result3[con2].tipo,
                    platillo: result3[con2].nombre,
                    opciones: JSON.parse(result3[con2].opciones),
                    precio: result3[con2].precio,
                    cancelacion: result3[con2].cancelacion,
                    cantidad: result3[con2].cantidad,
                    impreso: result3[con2].impreso,
                    comentario:result3[con2].comentario,
                    idAreaImpresora:result3[con2].idAreaImpresora,
                    producto:result3[con2],
                    descuento:result3[con2].descuento
                 
                  })
                  con2 = con2 + 1
              }
              
              array.push(cuenta)
              cont = cont + 1
          } 
          res.status(200).send(array)
          db.end();
         return 

          
      })  
    }) 
    
     
        

      


        //res.status(200).send([])
   
    /*Mesa.findOne({ _id: mesaID }, (err, encontrado) => {
        if (err) {
            res.status(500).send({ message: 'Error al buscar' });
        } else {
            if (!encontrado) {
                res.status(404).send({ message: 'Error al buscar mesa' })
            } else {
                res.status(200).send({ encontrado })
            }
        }
    })*/
}

function buscarMesaBy(req, res) {
  
    var number = req.params.num;
    var type = req.params.tipo;
   let  sql = `SELECT * from cuentas WHERE numeroMesa = '${number}' AND tipodeMesa='${type}' `;
   const db =sqldb()
  db.query (sql,(err,result)=>{
     

      if(err){
        db.end();
        return res.status(200).send({Error:"db Error"})
      }else{
        db.end();
        return res.status(200).send(result[0])
      }

    
  })

  

    /*Mesa.findOne({ numero: number, tipo: type }, (err, encontrado) => {
        if (err) return res.status(500).send({ message: 'Error al buscar' });
        
        if (!encontrado) return res.status(404).send({ message: 'Error al buscar mesa' })

        return res.status(200).send({ encontrado })
    })*/
}

function buscarMesaTipo(req, res) {
    var type = req.params.tipo
  
   // let  sql = `SELECT * from mesas  WHERE tipo = '${type}'`;
   let  sql =  `SELECT mesas.id AS id, mesas.numero AS numero,areas_Mesas.area AS tipo from mesas LEFT JOIN areas_Mesas ON mesas.idareas_Mesas = areas_Mesas.id WHERE areas_Mesas.area =  '${type}' AND  mesas.idEmpresas = '${process.env.idEmpresa}' `
    const db =sqldb()
    let query = db.query(sql,(err,result)=>{
       
       if(!result){
             db.end();
            res.status(200).send({message: 'Error al buscar mesa'})
            return
       }
        if(result.length === 0){
            db.end();
            res.status(200).send({message: 'Error al buscar mesa'})
            return
        }else if(err){
            db.end();
            res.status(200).send({ message: 'Error al buscar' })
            return
        }
    
            let  sql = `SELECT * from mesas INNER JOIN cuentas ON mesas.numero =  cuentas.numeroMesa WHERE tipodeMesa = '${type}'`;
            query = db.query(sql,(err,result2)=>{
            
                if(err){
                    console.log(err)
                    console.log("ERROR")
                    db.end();
                    res.status(200).send({ message: 'Error al buscar' })
                    return
                }
                var cont = 0
                var array = []

                while(cont<result.length){
                    const result3 = result2.filter(e => result[cont].numero == e.numeroMesa);
                    var suma_total = 0
                    var cont2 = 0
                    while(cont2<result3.length){
                        suma_total = result3[cont2].total +suma_total
                        cont2 = cont2 + 1
                    }
                    array.push({mesa:result[cont],
                                cuentas:result3,
                                total:suma_total})
                    cont = cont + 1
                }     
                db.end();
                res.status(200).send(array)
                return
                
                
            })
            
       

       
          
    })
   // res.status(200).send([])
    /*Mesa.find({ tipo: type }, (err, encontrado) => {
        if (err) {
            res.status(500).send({ message: 'Error al buscar' });
        } else {
            if (!encontrado) {
                res.status(404).send({ message: 'Error al buscar mesa' })
            } else {
                res.status(200).send(encontrado)
            }
        }
    })*/

}

function getAreasMesas(req, res){
    let  sql = `SELECT * from areas_Mesas WHERE  idEmpresas = '${process.env.idEmpresa}'`;
    const db =sqldb()
    let query = db.query(sql,(err,result)=>{
            if(err){
                db.end();
                return res.status(200).send({Error:"Al buscar area"})
            }
            db.end();
            res.status(200).send(result)
    })
    
}

module.exports = {
    guardarMesa,
    actualizarMesa,
    eliminarMesa,
    listarMesa,
    buscarMesa,
    buscarMesaTipo,
    buscarMesaBy,
    agregarCuenta,
    getAreasMesas
}